
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Distribution_platformsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const distribution_platforms = await db.distribution_platforms.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        category: data.category
        ||
        null
            ,
            
        website_url: data.website_url
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await distribution_platforms.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.distribution_platforms.getTableName(),
                belongsToColumn: 'logo',
                belongsToId: distribution_platforms.id,
            },
            data.logo,
            options,
        );
        

        return distribution_platforms;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const distribution_platformsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                category: item.category
            ||
            null
            ,
            
                website_url: item.website_url
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const distribution_platforms = await db.distribution_platforms.bulkCreate(distribution_platformsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < distribution_platforms.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.distribution_platforms.getTableName(),
                    belongsToColumn: 'logo',
                    belongsToId: distribution_platforms[i].id,
                },
                data[i].logo,
                options,
            );
        }
        

        return distribution_platforms;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const distribution_platforms = await db.distribution_platforms.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.website_url !== undefined) updatePayload.website_url = data.website_url;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await distribution_platforms.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await distribution_platforms.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.distribution_platforms.getTableName(),
                belongsToColumn: 'logo',
                belongsToId: distribution_platforms.id,
            },
            data.logo,
            options,
        );
        

        return distribution_platforms;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const distribution_platforms = await db.distribution_platforms.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of distribution_platforms) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of distribution_platforms) {
                await record.destroy({transaction});
            }
        });


        return distribution_platforms;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const distribution_platforms = await db.distribution_platforms.findByPk(id, options);

        await distribution_platforms.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await distribution_platforms.destroy({
            transaction
        });

        return distribution_platforms;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const distribution_platforms = await db.distribution_platforms.findOne(
            { where },
            { transaction },
        );

        if (!distribution_platforms) {
            return distribution_platforms;
        }

        const output = distribution_platforms.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.release_deliveries_platform = await distribution_platforms.getRelease_deliveries_platform({
            transaction
        });
        
        
        
        output.smart_link_destinations_platform = await distribution_platforms.getSmart_link_destinations_platform({
            transaction
        });
        
        
        output.smart_link_clicks_platform = await distribution_platforms.getSmart_link_clicks_platform({
            transaction
        });
        
        
        output.playlists_platform = await distribution_platforms.getPlaylists_platform({
            transaction
        });
        
        
        
        
        output.royalty_reports_platform = await distribution_platforms.getRoyalty_reports_platform({
            transaction
        });
        
        
        
        
        
        
        
        
        output.analytics_daily_platform = await distribution_platforms.getAnalytics_daily_platform({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.logo = await distribution_platforms.getLogo({
            transaction
        });
        
        
        output.organizations = await distribution_platforms.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'logo',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'distribution_platforms',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.website_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'distribution_platforms',
                        'website_url',
                        filter.website_url,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.distribution_platforms.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'distribution_platforms',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.distribution_platforms.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

